#
# Barpanel "Launcher" plugin
# 
# Copyright (C) 2008 Job and Esther Technologies Ltd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

name = "Launcher"
description = """Custom application launcher."""

import barpanel, gtk, gobject, os

class Plugin(barpanel.Plugin):
    def __init__(self, panel, settings):
        barpanel.Plugin.__init__(self, panel, settings)
        btn = gtk.Button()
        btn.set_name("EdgeButton")
        btn.connect("clicked", self.onClicked)
        btn.set_relief(gtk.RELIEF_NONE)
        self.add(btn)
        box = gtk.HBox(False, 4)
        btn.add(box)
        if settings.has_key('icon') and settings['icon'] != None and len(settings['icon'])>0:
            img = panel.get_image_from_icon_name(settings['icon'])
            box.pack_start(img, False, True)
        if settings.has_key('label') and settings['label'] != None and len(settings['label'])>0:
            lbl = gtk.Label(settings['label'])
            panel.update_font(self, lbl)
            lbl.set_justify(gtk.JUSTIFY_LEFT)
            lbl.set_alignment(0, 0.5)
            box.pack_start(lbl, True, True)
        if settings.has_key('desc') and settings['desc'] != None and len(settings['desc'])>0:
            barpanel.tooltips.set_tip(btn, settings['desc'])
        else:
            barpanel.tooltips.set_tip(btn, settings['command'])
        self.command = settings['command']
        self.show_all()

    def onClicked(self, btn):
        print _("Launcher: launching '%s'") % (self.command)
        os.spawnl(os.P_NOWAIT, "/bin/sh", "/bin/sh", "-c", self.command)
